VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PCCFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Project Name: PCC File
'Project Type: A Class (PCCFile) for manipulating sequential text files along with a testing form
'Developed by: Md. Ashfaqur Rahman
'Organisation: Prompt Computers & Communications
'              Tongi, Bangladesh
'Contact     : rahman@pccworld.com (pls send ur feedback and suggestions regarding the control)

Option Explicit
Dim strFileName As String   'Property that stores File Path + Name
Dim wmWriteMode As WMode    'Property that determines the write mode
Dim strFileText() As String 'Property that holds the file text after ReadFromFile method call
Dim intTotalLine As Integer 'Property that holds the total line number retrieved from a file by calling ReadFromFile method

Public Enum WMode 'Enum data type used to determine the Write Mode
  AddToFile = 1
  NewFile = 2
End Enum

'Method to write text into a file
'Arguments:
'           FileText  - text tobe written into the file
'           FileName  - (Optional) sets the FileName Property
'           WriteMode - (Optional) sets the WriteMode property
Public Sub WriteToFile(ByVal FileText As String, Optional ByVal FileName As String, Optional ByVal WriteMode As WMode)
  On Error GoTo ErrHandle
  
  Dim FileNo As Integer
  
  'set optional values
  If FileName <> "" Then
    strFileName = FileName
  End If
  If WriteMode > 0 Then
    wmWriteMode = WriteMode
  End If
  
  'Open the file to write data into
  FileNo = FreeFile
  If wmWriteMode = AddToFile Then
    Open strFileName For Append As FileNo
  ElseIf wmWriteMode = NewFile Then
    Open strFileName For Output As FileNo
  End If
  Print #FileNo, FileText
  Close FileNo
  Exit Sub
ErrHandle:
  MsgBox Err.Number & " : " & Err.Description
End Sub

Private Sub Class_Initialize()
  wmWriteMode = AddToFile 'Sets the default value of WriteMode property
End Sub

Public Property Get FileName() As String
  FileName = strFileName
End Property

Public Property Let FileName(ByVal FName As String)
  strFileName = FName
End Property

Public Property Get WriteMode() As WMode
  WriteMode = wmWriteMode
End Property

Public Property Let WriteMode(ByVal WrMode As WMode)
  wmWriteMode = WrMode
End Property

'Function to Read Text from a file
'Arguments:
'           FileName  - (Optional) sets the FileName Property
'Actions:
'         * Read data line by line from the file indicated by FileName Property
'         * Stores the retrieved line to FileText Property as a Text Array
'         * Set property TotalLine to show how many lines retrieved from the file
'         * Return a text to the calling function that combines all the retrieved lines by carriege return
Public Function ReadFromFile(Optional ByVal FileName As String) As String
  On Error GoTo ErrHandle
  Dim FileNo As Integer
  Dim Counter As Integer
  Dim ReturnText As String
  
  If FileName <> "" Then
    strFileName = FileName
  End If
  Counter = 0
  FileNo = FreeFile
  
  Open strFileName For Input As FileNo
  Do Until EOF(FileNo)
    ReDim Preserve strFileText(Counter + 1)
    Line Input #FileNo, strFileText(Counter)
    'Return Text
    If ReturnText <> "" Then ReturnText = ReturnText & vbCrLf
    ReturnText = ReturnText & strFileText(Counter)
    Counter = Counter + 1
  Loop
  intTotalLine = Counter
  Close FileNo
  ReadFromFile = ReturnText
  Exit Function
ErrHandle:
  MsgBox Err.Number & " : " & Err.Description
End Function

Public Property Get FileText(LineNumber As Integer) As String
  FileText = strFileText(LineNumber - 1)
End Property

Public Property Get TotalLine() As Integer
  TotalLine = intTotalLine
End Property
